#!/usr/local/bin/gawk -f

# make an established tactics table of taka's thinking routine
# for the Weakest Othello League

BEGIN {
	# s -> (m, mn) : ʬ
	# (s, o) -> on : 
	
	statc = 0
	opc = 0
	
	regmy("", "65")
	regop("65")
}

/^[ \t]*$/ { next }
/^[ \t]*;/ { next }

/^[ \t1-8a-h]+:[ \t]*([1-8a-h]+|pass)[ \t]*(;.*)?$/ {
	sub(/[ \t]*;.*$/, "")
	if ($0 !~ /^[ \t]*([1-8a-h][1-8][ \t]*)*:[ \t]*(([1-8a-h][1-8])|pass)[ \t]*$/) {
		printf("err line %d: %s\n", NR, $0) > "/dev/stderr"
		next
	}
	p = $0
	gsub(/pass/, "00", p)
	gsub(/a/, "1", p)
	gsub(/b/, "2", p)
	gsub(/c/, "3", p)
	gsub(/d/, "4", p)
	gsub(/e/, "5", p)
	gsub(/f/, "6", p)
	gsub(/g/, "7", p)
	gsub(/h/, "8", p)
	gsub(/[ \t]/, "", p)
	m = p
	sub(/:.*/, "", p)
	sub(/.*:/, "", m)
	if (p == "") {
		next
	}
	
	regop(p)
	if (m != "00") regmy(p, m)
	next
}

{
	printf "error : " $0 >"/dev/stderr"
	next
}

END {
	# sc:ֹ->ֹѴ scc:MY
	for (l=0; l<statc; l++) {
		if (l in my) {
			sc[scc++] = l
		}else {
			sco[scoc++] = l
		}
	}
	for (l=0; l<scoc; l++) sc[scc+l] = sco[l]
	# Ѵơ֥(ֹ->ֹ) 
	for (l=0; l<statc; l++) scr[sc[l]] = l
	
	print "#MY ", scc
	for (l=0; l<scc; l++) {
		printf("%-5d %2d %5d\n", l, convhand(my[sc[l]]), scr[mynext[sc[l]]])
	}
	
	print ""
	print "#OP ", opc
	for (l=0; l<opc; l++) {
		printf("%-5d %2d %5d\n", scr[ops[l]], convhand(opo[l]), scr[opn[l]])
	}
	
}

#
function getstat(s) {
	if (s in stattbl) return stattbl[s]
	stattbl[s] = statc
	statrtbl[statc] = s
	return statc++
}

function regmy(s, m   ,a) {
	a = getstat(s)
	my[a] = m
	mynext[a] = getstat(s m)
}

function regop(s   ,a,b) {
	a = substr(s, 1, length(s)-2)
	b = substr(s, length(s)-1, 2)
	ops[opc] = getstat(a)
	opo[opc] = b
	opn[opc] = getstat(s)
	opc++
}

function convhand(s, a,b) {
	a = substr(s, 1, 1)
	b = substr(s, 2, 1)
	return b*9 + a
}
